from wxPython.wx import *
from U6.HexCtrl import HexCtrl

# HexCtrl-derived class that selects/deselects text on focus/defocus.
class HexCtrl_focus(HexCtrl):
	def __init__(self, *args, **kwargs):
		HexCtrl.__init__(self, *args, **kwargs)
		EVT_SET_FOCUS(self, self.OnFocus)
		EVT_KILL_FOCUS(self, self.OnLostFocus)

	def OnFocus(self, event):
		# This only works for keyboard, but that's what I want.
		HexCtrl.SetSelection(self, -1, -1)
		event.Skip()

	def OnLostFocus(self, event):
		HexCtrl.SetSelection(self, 0, 0)
		event.Skip()

class GoToDialog(wxDialog):
	def __init__(self, parent, coords=None):
		wxDialog.__init__(self, parent, -1, "Go to...", style=wxCAPTION | wxSYSTEM_MENU | wxTHICK_FRAME)
		sizer = wxBoxSizer(wxVERTICAL)
		gs = wxGridSizer(3, 2, 5, 5)
		x = HexCtrl_focus(self, wxNewId(), min=0, max=0x3ff, limited=1)
		y = HexCtrl_focus(self, wxNewId(), min=0, max=0x3ff, limited=1)
		z = HexCtrl_focus(self, wxNewId(), min=0, max=5,     limited=1)

		self.controls = ( ('x', x), ('y', y), ('z', z) )
		for text, ctrl in self.controls:
			gs.Add(wxStaticText(self, wxNewId(), text, style=wxALIGN_RIGHT), 0, wxALIGN_CENTER_VERTICAL | wxALIGN_RIGHT)
			gs.Add(ctrl, 0, wxEXPAND)
		sizer.Add(gs, 0, wxEXPAND|wxALL, 3)

		if coords:
			x.SetValue(coords[0])
			y.SetValue(coords[1])
			z.SetValue(coords[2])

		# Add OK/Cancel buttons
		line = wxStaticLine(self, -1, style=wxLI_HORIZONTAL)
		sizer.Add(line, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5)

		box = wxBoxSizer(wxHORIZONTAL)

		btn = wxButton(self, wxID_OK, " OK ")
		btn.SetDefault()
		box.Add(btn, 1, wxALIGN_CENTRE|wxALL, 5)
		btn = wxButton(self, wxID_CANCEL, " Cancel ")
		box.Add(btn, 1, wxALIGN_CENTRE|wxALL, 5)
		sizer.Add(box, 0, wxEXPAND|wxALL, 5)
		self.SetSizer(sizer)
		sizer.Fit(self)

	def Values(self):
		return [ ctrl.GetValue() for text, ctrl in self.controls ]


class GoToApp(wxApp):
	def OnInit(self):
		d = GoToDialog(None)
		val = d.ShowModal()
		if val == wxID_OK:
			print d.Values()
		d.Destroy()
		return true

if __name__ == '__main__':
	app = GoToApp(0)
	app.MainLoop()
